//
//  BYBasePickerScrollView.m
//  pickerScollview
//
//  Created by qiubing on 2017/5/4.
//  Copyright © 2017年 qbiboyaa. All rights reserved.
//

#import "BYBasePickerScrollView.h"
#define kSCREEN_W [UIScreen mainScreen].bounds.size.width
#define kSCREEN_H [UIScreen mainScreen].bounds.size.height
//typedef void(^imageClick)(NSInteger imageIndex);
@interface BYBasePickerScrollView()
@property(nonatomic,strong)UIScrollView *pickerScollView;
@property(nonatomic,assign)CGRect rect;
@property(nonatomic,strong)UIButton *currentBtn;
@property(nonatomic,assign)CGFloat itemsWidth;

@end

@implementation BYBasePickerScrollView

-(instancetype)initWithFrame:(CGRect)frame{
    self = [super initWithFrame:frame];
    if (self) {
//        self.userInteractionEnabled = YES;
        
        _pickerScollView = [[UIScrollView alloc] initWithFrame:CGRectMake(0, 0, frame.size.width, frame.size.height)];
        _pickerScollView.backgroundColor = [UIColor redColor];
        _pickerScollView.showsHorizontalScrollIndicator = NO;
        _pickerScollView.bounces = NO;
        _pickerScollView.userInteractionEnabled = YES;
        _rect = CGRectMake(0, 0, frame.size.width, frame.size.height);
        [self addSubview:_pickerScollView];
    }
    return self;
}
/**
创建选择器

@param itemArray item名称
@param width 每个item宽
@param itemsBackgroundColor item背景颜色
@param itemsNormalColor item文字没被选中的颜色
@param itemsSelectedColor item文字被选中的颜色
*/
-(void)pickerSVWithArray:(NSArray *)itemArray
              ItemsWidth:(CGFloat)width
    ItemsBackgroundColor:(UIColor *)itemsBackgroundColor
        ItemsNormalColor:(UIColor *)itemsNormalColor
      ItemsSelectedColor:(UIColor *)itemsSelectedColor{
    
    _pickerScollView.contentSize = CGSizeMake(width*itemArray.count, _rect.size.height);
    _itemsWidth = width;
    for (int i=0; i<itemArray.count; i++) {
        UIButton *button = [UIButton buttonWithType:UIButtonTypeCustom];
        button.frame = CGRectMake(100*i, 0, width, _rect.size.height);
        button.backgroundColor = itemsBackgroundColor;
        [button setTitleColor:itemsSelectedColor forState:UIControlStateSelected];
        [button setTitleColor:itemsNormalColor forState:UIControlStateNormal];
        
        [button setTitle:itemArray[i] forState:UIControlStateNormal];
        [_pickerScollView addSubview:button];
        button.tag = 100+i;
//        button.userInteractionEnabled = YES;
//        button.enabled = YES;
        [button addTarget:self action:@selector(clickqqq:) forControlEvents:UIControlEventTouchUpInside];
        if (button.tag == 100) {
            button.selected = YES;
            _currentBtn = button;
            
        }
    }
}
-(void)clickqqq:(UIButton *)sender{
    _currentBtn.selected = NO;
    sender.selected = YES;
    _currentBtn = sender;
    //    long i = sender.tag-22;
    if (sender.frame.origin.x > _pickerScollView.contentSize.width-kSCREEN_W/2.0-_itemsWidth/2.0 ) {
        _pickerScollView.contentOffset = CGPointMake(_pickerScollView.contentSize.width-kSCREEN_W, 0);
        
    }else if (sender.frame.origin.x < kSCREEN_W/2.0-_itemsWidth/2.0){
        _pickerScollView.contentOffset = CGPointMake(0, 0);
    }else{
        _pickerScollView.contentOffset = CGPointMake(sender.frame.origin.x+_itemsWidth/2.0-kSCREEN_W/2.0, 0);
    }
    if (_btnAfterClick) {
        _btnAfterClick(sender.tag);
    }
    
}
@end
